Index: smf/Sources/Subs-Graphics.php
===================================================================
--- smf/Sources/Subs-Graphics.php	(revision 1047)
+++ smf/Sources/Subs-Graphics.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -127,10 +127,13 @@
 
 	require_once($sourcedir . '/ManageAttachments.php');
 	removeAttachments('a.ID_MEMBER = ' . $memID);
+
+	$avatar_hash = empty($modSettings['custom_avatar_enabled']) ? getAttachmentFilename($destName, false, true) : '';
+
 	db_query("
 		INSERT INTO {$db_prefix}attachments
-			(ID_MEMBER, attachmentType, filename, size)
-		VALUES ($memID, " . (empty($modSettings['custom_avatar_enabled']) ? '0' : '1') . ", '$destName', 1)", __FILE__, __LINE__);
+			(ID_MEMBER, attachmentType, filename, file_hash, size)
+		VALUES ($memID, " . (empty($modSettings['custom_avatar_enabled']) ? '0' : '1') . ", '$destName', '" . (empty($avatar_hash) ? "" : "$avatar_hash") . "', 1)", __FILE__, __LINE__);
 	$attachID = db_insert_id();
 
 	$destName = (empty($modSettings['custom_avatar_enabled']) ? $modSettings['attachmentUploadDir'] : $modSettings['custom_avatar_dir']) . '/' . $destName . '.tmp';
@@ -143,14 +146,38 @@
 	$fp = fopen($destName, 'wb');
 	if ($fp && substr($url, 0, 7) == 'http://')
 	{
-		fwrite($fp, fetch_web_data($url));
+		$fileContents = fetch_web_data($url);
+
+		// Though not an exhaustive list, better safe than sorry.
+		if (preg_match('~(iframe|\\<\\?php|\\<\\?[\s=]|\\<%[\s=]|html|eval|body|script\W)~', $fileContents) === 1)
+		{
+			fclose($fp);
+			return false;
+		}
+
+		fwrite($fp, $fileContents);
 		fclose($fp);
 	}
 	elseif ($fp)
 	{
 		$fp2 = fopen($url, 'rb');
+		$prev_chunk = '';
 		while (!feof($fp2))
-			fwrite($fp, fread($fp2, 8192));
+		{
+			$cur_chunk = fread($fp2, 8192);
+
+			// Make sure nothing odd came through.
+			if (preg_match('~(iframe|\\<\\?php|\\<\\?[\s=]|\\<%[\s=]|html|eval|body|script\W)~', $prev_chunk . $cur_chunk) === 1)
+			{
+				fclose($fp2);
+				fclose($fp);
+				unlink($destName);
+				return false;
+			}
+
+			fwrite($fp, $cur_chunk);
+			$prev_chunk = $cur_chunk;
+		}
 		fclose($fp2);
 		fclose($fp);
 	}
@@ -183,8 +210,9 @@
 	if ($success)
 	{
 		// Remove the .tmp extension from the attachment.
-		if (rename($destName . '.tmp', $destName))
+		if (rename($destName . '.tmp', empty($avatar_hash) ? $destName : $modSettings['attachmentUploadDir'] . '/' . $attachID . '_' . $avatar_hash))
 		{
+			$destName = empty($avatar_hash) ? $destName : $modSettings['attachmentUploadDir'] . '/' . $attachID . '_' . $avatar_hash;
 			list ($width, $height) = getimagesize($destName);
 
 			// Write filesize in the database.
@@ -1406,7 +1434,7 @@
 	}
 
 	// Create an image.
-	$code_image = imagecreate($total_width, $max_height);
+	$code_image = $gd2 ? imagecreatetruecolor($total_width, $max_height) : imagecreate($total_width, $max_height);
 
 	// Draw the background.
 	$bg_color = imagecolorallocate($code_image, $background_color[0], $background_color[1], $background_color[2]);
@@ -1414,12 +1442,12 @@
 
 	// Randomize the foreground color a little.
 	for ($i = 0; $i < 3; $i++)
-		$foreground_color[$i] = rand(max($foreground_color[$i] - 3, 0), min($foreground_color[$i] + 3, 255));
+		$foreground_color[$i] = mt_rand(max($foreground_color[$i] - 3, 0), min($foreground_color[$i] + 3, 255));
 	$fg_color = imagecolorallocate($code_image, $foreground_color[0], $foreground_color[1], $foreground_color[2]);
 
 	// Color for the dots.
 	for ($i = 0; $i < 3; $i++)
-		$dotbgcolor[$i] = $background_color[$i] < $foreground_color[$i] ? rand(0, max($foreground_color[$i] - 20, 0)) : rand(min($foreground_color[$i] + 20, 255), 255);
+		$dotbgcolor[$i] = $background_color[$i] < $foreground_color[$i] ? mt_rand(0, max($foreground_color[$i] - 20, 0)) : mt_rand(min($foreground_color[$i] + 20, 255), 255);
 	$randomness_color = imagecolorallocate($code_image, $dotbgcolor[0], $dotbgcolor[1], $dotbgcolor[2]);
 
 	// Fill in the characters.
@@ -1435,7 +1463,7 @@
 			if ($rotationType == 'none')
 				$angle = 0;
 			else
-				$angle = rand(-100, 100) / ($rotationType == 'high' ? 6 : 10);
+				$angle = mt_rand(-100, 100) / ($rotationType == 'high' ? 6 : 10);
 
 			// What colour shall we do it?
 			if ($fontColorType == 'cyclic')
@@ -1453,12 +1481,12 @@
 					$last_index = -1;
 				$new_index = $last_index;
 				while ($last_index == $new_index)
-					$new_index = rand(0, count($colours) - 1);
+					$new_index = mt_rand(0, count($colours) - 1);
 				$char_fg_color = $colours[$new_index];
 				$last_index = $new_index;
 			}
 			elseif ($fontColorType == 'random')
-				$char_fg_color = array(rand(max($foreground_color[0] - 2, 0), $foreground_color[0]), rand(max($foreground_color[1] - 2, 0), $foreground_color[1]), rand(max($foreground_color[2] - 2, 0), $foreground_color[2]));
+				$char_fg_color = array(mt_rand(max($foreground_color[0] - 2, 0), $foreground_color[0]), mt_rand(max($foreground_color[1] - 2, 0), $foreground_color[1]), mt_rand(max($foreground_color[2] - 2, 0), $foreground_color[2]));
 			else
 				$char_fg_color = array($foreground_color[0], $foreground_color[1], $foreground_color[2]);
 
@@ -1466,20 +1494,20 @@
 			{
 				// GD2 handles font size differently.
 				if ($fontSizeRandom)
-					$font_size = $gd2 ? rand(17, 19) : rand(18, 25);
+					$font_size = $gd2 ? mt_rand(17, 19) : mt_rand(18, 25);
 				else
 					$font_size = $gd2 ? 18 : 24;
 	
 				// Work out the sizes - also fix the character width cause TTF not quite so wide!
 				$font_x = $fontHorSpace == 'minus' && $cur_x > 0 ? $cur_x - 3 : $cur_x + 5;
-				$font_y = $max_height - ($fontVerPos == 'vrandom' ? rand(2, 8) : ($fontVerPos == 'random' ? rand(3, 5) : 5));
+				$font_y = $max_height - ($fontVerPos == 'vrandom' ? mt_rand(2, 8) : ($fontVerPos == 'random' ? mt_rand(3, 5) : 5));
 	
 				// What font face?
 				if (!empty($ttfont_list))
-					$fontface = $settings['default_theme_dir'] . '/fonts/' . $ttfont_list[rand(0, count($ttfont_list) - 1)];
+					$fontface = $settings['default_theme_dir'] . '/fonts/' . $ttfont_list[mt_rand(0, count($ttfont_list) - 1)];
 	
 				// What color are we to do it in?
-				$is_reverse = $showReverseChars ? rand(0, 1) : false;
+				$is_reverse = $showReverseChars ? mt_rand(0, 1) : false;
 				$char_color = function_exists('imagecolorallocatealpha') && $fontTrans ? imagecolorallocatealpha($code_image, $char_fg_color[0], $char_fg_color[1], $char_fg_color[2], 50) : imagecolorallocate($code_image, $char_fg_color[0], $char_fg_color[1], $char_fg_color[2]);
 	
 				$fontcord = @imagettftext($code_image, $font_size, $angle, $font_x, $font_y, $char_color, $fontface, $character['id']);
@@ -1505,7 +1533,7 @@
 					$char_bgcolor = imagecolorallocate($char_image, $background_color[0], $background_color[1], $background_color[2]);
 					imagefilledrectangle($char_image, 0, 0, $character['width'] - 1, $character['height'] - 1, $char_bgcolor);
 					imagechar($char_image, $loaded_fonts[$character['font']], 0, 0, $character['id'], imagecolorallocate($char_image, $char_fg_color[0], $char_fg_color[1], $char_fg_color[2]));
-					$rotated_char = imagerotate($char_image, rand(-100, 100) / 10, $char_bgcolor);
+					$rotated_char = imagerotate($char_image, mt_rand(-100, 100) / 10, $char_bgcolor);
 					imagecopy($code_image, $rotated_char, $cur_x, 0, 0, 0, $character['width'], $character['height']);
 					imagedestroy($rotated_char);
 					imagedestroy($char_image);
@@ -1534,9 +1562,9 @@
 	// Add some noise to the background?
 	if ($noiseType != 'none')
 	{
-		for ($i = rand(0, 2); $i < $max_height; $i += rand(1, 2))
-			for ($j = rand(0, 10); $j < $total_width; $j += rand(1, 15))
-				imagesetpixel($code_image, $j, $i, rand(0, 1) ? $fg_color : $randomness_color);
+		for ($i = mt_rand(0, 2); $i < $max_height; $i += mt_rand(1, 2))
+			for ($j = mt_rand(0, 10); $j < $total_width; $j += mt_rand(1, 15))
+				imagesetpixel($code_image, $j, $i, mt_rand(0, 1) ? $fg_color : $randomness_color);
 
 		// Put in some lines too?
 		if ($noiseType == 'high')
@@ -1544,20 +1572,20 @@
 			$num_lines = 2;
 			for ($i = 0; $i < $num_lines; $i++)
 			{
-				if (rand(0, 1))
+				if (mt_rand(0, 1))
 				{
-					$x1 = rand(0, $total_width);
-					$x2 = rand(0, $total_width);
+					$x1 = mt_rand(0, $total_width);
+					$x2 = mt_rand(0, $total_width);
 					$y1 = 0; $y2 = $max_height;
 				}
 				else
 				{
-					$y1 = rand(0, $max_height);
-					$y2 = rand(0, $max_height);
+					$y1 = mt_rand(0, $max_height);
+					$y2 = mt_rand(0, $max_height);
 					$x1 = 0; $x2 = $total_width;
 				}
 		
-				imageline($code_image, $x1, $y1, $x2, $y2, rand (0, 1) ? $fg_color : $randomness_color);
+				imageline($code_image, $x1, $y1, $x2, $y2, mt_rand(0, 1) ? $fg_color : $randomness_color);
 			}
 		}
 	}
Index: smf/Sources/Subs-Members.php
===================================================================
--- smf/Sources/Subs-Members.php	(revision 1047)
+++ smf/Sources/Subs-Members.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -644,13 +644,13 @@
 	// Generate a validation code if it's supposed to be emailed.
 	$validation_code = '';
 	if ($regOptions['require'] == 'activation')
-		$validation_code = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+		$validation_code = generateValidationCode();
 
 	// If you haven't put in a password generated one.
 	if ($regOptions['interface'] == 'admin' && $regOptions['password'] == '')
 	{
-		srand(time() + 1277);
-		$regOptions['password'] = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+		mt_srand(time() + 1277);
+		$regOptions['password'] = generateValidationCode();
 		$regOptions['password_check'] = $regOptions['password'];
 	}
 	// Does the first password match the second?
@@ -687,12 +687,35 @@
 		fatal_error(sprintf($txt[730], htmlspecialchars($regOptions['email'])), false);
 	mysql_free_result($request);
 
+	$reservedVars = array(
+		'actual_theme_url',
+		'actual_images_url',
+		'base_theme_dir',
+		'base_theme_url',
+		'default_images_url',
+		'default_theme_dir',
+		'default_theme_url',
+		'default_template',
+		'images_url',
+		'number_recent_posts',
+		'smiley_sets_default',
+		'theme_dir',
+		'theme_id',
+		'theme_layers',
+		'theme_templates',
+		'theme_url',
+	);
+
+	// Can't change reserved vars.
+	if (isset($regOptions['theme_vars']) && array_intersect(array_keys($regOptions['theme_vars']), $reservedVars) != array())
+		fatal_lang_error('theme3');
+
 	// Some of these might be overwritten. (the lower ones that are in the arrays below.)
 	$regOptions['register_vars'] = array(
 		'memberName' => "'$regOptions[username]'",
 		'emailAddress' => "'$regOptions[email]'",
 		'passwd' => '\'' . sha1(strtolower($regOptions['username']) . $regOptions['password']) . '\'',
-		'passwordSalt' => '\'' . substr(md5(rand()), 0, 4) . '\'',
+		'passwordSalt' => '\'' . substr(md5(mt_rand()), 0, 4) . '\'',
 		'posts' => 0,
 		'dateRegistered' => time(),
 		'memberIP' => "'$user_info[ip]'",
@@ -1094,5 +1117,18 @@
 	// Redirect back to the profile
 	redirectexit('action=profile;u=' . $_REQUEST['u']);
 }
+// Generate a random validation code.
+function generateValidationCode()
+{
+	global $modSettings;
+	
+	$request = db_query('
+		SELECT RAND()', __FILE__, __LINE__);
+	
+	list ($dbRand) = mysql_fetch_row($request);
+	mysql_free_result($request);
+	
+	return substr(preg_replace('/\W/', '', sha1(microtime() . mt_rand() . $dbRand . $modSettings['rand_seed'])), 0, 10);	
+}
 
 ?>
\ No newline at end of file
Index: smf/Sources/Subs-Post.php
===================================================================
--- smf/Sources/Subs-Post.php	(revision 1047)
+++ smf/Sources/Subs-Post.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -230,7 +230,7 @@
 				$parts[$i] = $parts[$i] . str_repeat('[/list]', $list_open - $list_close);
 
 			// Make sure all tags are lowercase.
-			$parts[$i] = preg_replace('~\[([/]?)(list|li|table|tr|td)([^\]]*)\]~ie', '\'[$1\' . strtolower(\'$2\') . \'$3]\'', $parts[$i]);
+			$parts[$i] = preg_replace('~\[([/]?)(list|li|table|tr|td)((\s[^\]]+)*)\]~ie', '\'[$1\' . strtolower(\'$2\') . \'$3]\'', $parts[$i]);
 
 			$mistake_fixes = array(
 				// Find [table]s not followed by [tr].
@@ -306,8 +306,8 @@
 		}
 	}
 
-	// Change breaks back to \n's.
-	return preg_replace('~<br( /)?' . '>~', "\n", implode('', $parts));
+	// Change breaks back to \n's and &nsbp; back to spaces.
+	return preg_replace('~<br( /)?' . '>~', "\n", str_replace('&nbsp;', ' ', implode('', $parts)));
 }
 
 // Fix any URLs posted - ie. remove 'javascript:'.
@@ -461,7 +461,7 @@
 	$replaces = array();
 
 	if ($hasEqualSign)
-		preg_match_all('~\[(' . $myTag . ')=([^\]]*?)\](.+?)\[/(' . $myTag . ')\]~is', $message, $matches);
+		preg_match_all('~\[(' . $myTag . ')=([^\]]*?)\](?:(.+?)\[/(' . $myTag . ')\])?~is', $message, $matches);
 	else
 		preg_match_all('~\[(' . $myTag . ($hasExtra ? '(?:[^\]]*?)' : '') . ')\](.+?)\[/(' . $myTag . ')\]~is', $message, $matches);
 
@@ -470,10 +470,7 @@
 		// Remove all leading and trailing whitespace.
 		$replace = trim($matches[2][$k]);
 		$this_tag = $matches[1][$k];
-		if (!$hasEqualSign)
-			$this_close = $matches[3][$k];
-		else
-			$this_close = $matches[4][$k];
+		$this_close = $hasEqualSign ? (empty($matches[4][$k]) ? '' : $matches[4][$k]) : $matches[3][$k];
 
 		$found = false;
 		foreach ($protocols as $protocol)
@@ -502,7 +499,7 @@
 			$replace = $protocols[0] . '://' . $replace;
 
 		if ($hasEqualSign && $embeddedUrl)
-			$replaces['[' . $matches[1][$k] . '=' . $matches[2][$k] . ']' . $matches[3][$k] . '[/' . $matches[4][$k] . ']'] = '[' . $this_tag . '=' . $replace . ']' . $matches[3][$k] . '[/' . $this_close . ']';
+			$replaces[$matches[0][$k]] = '[' . $this_tag . '=' . $replace . ']' . (empty($matches[4][$k]) ? '' : $matches[3][$k] . '[/' . $this_close . ']');
 		elseif ($hasEqualSign)
 			$replaces['[' . $matches[1][$k] . '=' . $matches[2][$k] . ']'] = '[' . $this_tag . '=' . $replace . ']';
 		elseif ($embeddedUrl)
@@ -1708,9 +1705,9 @@
 	if (!$file_restricted || $already_uploaded)
 		list ($attachmentOptions['width'], $attachmentOptions['height']) = @getimagesize($attachmentOptions['tmp_name']);
 
-	// Remove special foreign characters from the filename.
-	if (empty($modSettings['attachmentEncryptFilenames']))
-		$attachmentOptions['name'] = getAttachmentFilename($attachmentOptions['name'], false, true);
+	// Get the hash if no hash has been given yet.
+	if (empty($attachmentOptions['file_hash']))
+		$attachmentOptions['file_hash'] = getAttachmentFilename($attachmentOptions['name'], false, true);
 
 	// Is the file too big?
 	if (!empty($modSettings['attachmentSizeLimit']) && $attachmentOptions['size'] > $modSettings['attachmentSizeLimit'] * 1024)
@@ -1780,14 +1777,14 @@
 
 	db_query("
 		INSERT INTO {$db_prefix}attachments
-			(ID_MSG, filename, size, width, height)
-		VALUES (" . (int) $attachmentOptions['post'] . ", SUBSTRING('" . $attachmentOptions['name'] . "', 1, 255), " . (int) $attachmentOptions['size'] . ', ' . (empty($attachmentOptions['width']) ? '0' : (int) $attachmentOptions['width']) . ', ' . (empty($attachmentOptions['height']) ? '0' : (int) $attachmentOptions['height']) . ')', __FILE__, __LINE__);
+			(ID_MSG, filename, file_hash, size, width, height)
+		VALUES (" . (int) $attachmentOptions['post'] . ", SUBSTRING('" . $attachmentOptions['name'] . "', 1, 255), '$attachmentOptions[file_hash]', " . (int) $attachmentOptions['size'] . ', ' . (empty($attachmentOptions['width']) ? '0' : (int) $attachmentOptions['width']) . ', ' . (empty($attachmentOptions['height']) ? '0' : (int) $attachmentOptions['height']) . ')', __FILE__, __LINE__);
 	$attachmentOptions['id'] = db_insert_id();
 
 	if (empty($attachmentOptions['id']))
 		return false;
 
-	$attachmentOptions['destination'] = $modSettings['attachmentUploadDir'] . '/' . getAttachmentFilename(basename($attachmentOptions['name']), $attachmentOptions['id'], true);
+	$attachmentOptions['destination'] = getAttachmentFilename(basename($attachmentOptions['name']), $attachmentOptions['id'], false, $attachmentOptions['file_hash']);
 
 	if ($already_uploaded)
 		rename($attachmentOptions['tmp_name'], $attachmentOptions['destination']);
@@ -1826,10 +1823,11 @@
 			$thumb_size = filesize($attachmentOptions['destination'] . '_thumb');
 
 			// To the database we go!
+			$thumb_file_hash = getAttachmentFilename($thumb_filename, false, true);
 			db_query("
 				INSERT INTO {$db_prefix}attachments
-					(ID_MSG, attachmentType, filename, size, width, height)
-				VALUES (" . (int) $attachmentOptions['post'] . ", 3, SUBSTRING('$thumb_filename', 1, 255), " . (int) $thumb_size . ", " . (int) $thumb_width . ", " . (int) $thumb_height . ")", __FILE__, __LINE__);
+					(ID_MSG, attachmentType, filename, file_hash, size, width, height)
+				VALUES (" . (int) $attachmentOptions['post'] . ", 3, SUBSTRING('$thumb_filename', 1, 255), '$thumb_file_hash', " . (int) $thumb_size . ", " . (int) $thumb_width . ", " . (int) $thumb_height . ")", __FILE__, __LINE__);
 			$attachmentOptions['thumb'] = db_insert_id();
 
 			if (!empty($attachmentOptions['thumb']))
@@ -1840,7 +1838,7 @@
 					WHERE ID_ATTACH = $attachmentOptions[id]
 					LIMIT 1", __FILE__, __LINE__);
 
-				rename($attachmentOptions['destination'] . '_thumb', $modSettings['attachmentUploadDir'] . '/' . getAttachmentFilename($thumb_filename, $attachmentOptions['thumb'], true));
+				rename($attachmentOptions['destination'] . '_thumb', getAttachmentFilename($thumb_filename, $attachmentOptions['thumb'], false, $thumb_file_hash));
 			}
 		}
 	}
Index: smf/Sources/Subs-Sound.php
===================================================================
--- smf/Sources/Subs-Sound.php	(revision 1047)
+++ smf/Sources/Subs-Sound.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -48,7 +48,7 @@
 		cache_put_data('wave_file/' . $user_info['ip2'], $ip2 ? $ip2 + 1 : 1, 20);
 
 	// Fixate randomization for this word.
-	srand(end(unpack('n', md5($word . session_id()))));
+	mt_srand(end(unpack('n', md5($word . session_id()))));
 
 	// Try to see if there's a sound font in the user's language.
 	if (file_exists($settings['default_theme_dir'] . '/fonts/sound/a.' . $user_info['language'] . '.wav'))
@@ -74,17 +74,17 @@
 			return false;
 
 		$sound_letter = substr($sound_letter, strpos($sound_letter, 'data') + 8);
-		switch ($word{$i} === 's' ? 0 : rand(0, 2))
+		switch ($word{$i} === 's' ? 0 : mt_rand(0, 2))
 		{
 			case 0:
 				for ($j = 0, $n = strlen($sound_letter); $j < $n; $j++)
-					for ($k = 0, $m = round(rand(15, 25) / 10); $k < $m; $k++)
-						$sound_word .= $word{$i} === 's' ? $sound_letter{$j} : chr(rand(max(ord($sound_letter{$j}) - 1, 0x00), min(ord($sound_letter{$j}) + 1, 0xFF)));
+					for ($k = 0, $m = round(mt_rand(15, 25) / 10); $k < $m; $k++)
+						$sound_word .= $word{$i} === 's' ? $sound_letter{$j} : chr(mt_rand(max(ord($sound_letter{$j}) - 1, 0x00), min(ord($sound_letter{$j}) + 1, 0xFF)));
 			break;
 
 			case 1:
 				for ($j = 0, $n = strlen($sound_letter) - 1; $j < $n; $j += 2)
-					$sound_word .= (rand(0, 3) == 0 ? '' : $sound_letter{$j}) . (rand(0, 3) === 0 ? $sound_letter{$j + 1} : $sound_letter{$j}) . (rand(0, 3) === 0 ? $sound_letter{$j} : $sound_letter{$j + 1})  . $sound_letter{$j + 1} . (rand(0, 3) == 0 ? $sound_letter{$j + 1} : '');
+					$sound_word .= (mt_rand(0, 3) == 0 ? '' : $sound_letter{$j}) . (mt_rand(0, 3) === 0 ? $sound_letter{$j + 1} : $sound_letter{$j}) . (mt_rand(0, 3) === 0 ? $sound_letter{$j} : $sound_letter{$j + 1})  . $sound_letter{$j + 1} . (mt_rand(0, 3) == 0 ? $sound_letter{$j + 1} : '');
 				$sound_word .= str_repeat($sound_letter{$n}, 2);
 			break;
 
@@ -92,16 +92,16 @@
 				$shift = 0;
 				for ($j = 0, $n = strlen($sound_letter); $j < $n; $j++)
 				{
-					if (rand(0, 10) === 0)
-						$shift += rand(-3, 3);
-					for ($k = 0, $m = round(rand(15, 25) / 10); $k < $m; $k++)
+					if (mt_rand(0, 10) === 0)
+						$shift += mt_rand(-3, 3);
+					for ($k = 0, $m = round(mt_rand(15, 25) / 10); $k < $m; $k++)
 						$sound_word .= chr(min(max(ord($sound_letter{$j}) + $shift, 0x00), 0xFF));
 				}
 			break;
 
 		}
 
-		$sound_word .= str_repeat(chr(0x80), rand(10000, 10500));
+		$sound_word .= str_repeat(chr(0x80), mt_rand(10000, 10500));
 	}
 
 	$data_size = strlen($sound_word);
Index: smf/Sources/Themes.php
===================================================================
--- smf/Sources/Themes.php	(revision 1047)
+++ smf/Sources/Themes.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.2                                           *
+* Software Version:           SMF 1.1.7                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -1197,6 +1197,29 @@
 	if (empty($_GET['var']) || !isset($_GET['val']))
 		redirectexit($settings['images_url'] . '/blank.gif');
 
+	$reservedVars = array(
+		'actual_theme_url',
+		'actual_images_url',
+		'base_theme_dir',
+		'base_theme_url',
+		'default_images_url',
+		'default_theme_dir',
+		'default_theme_url',
+		'default_template',
+		'images_url',
+		'number_recent_posts',
+		'smiley_sets_default',
+		'theme_dir',
+		'theme_id',
+		'theme_layers',
+		'theme_templates',
+		'theme_url',
+	);
+
+	// Can't change reserved vars.
+	if (in_array(strtolower($_GET['var']), $reservedVars))
+		redirectexit($settings['images_url'] . '/blank.gif');
+
 	// Use a specific theme?
 	if (isset($_GET['th']) || isset($_GET['id']))
 		$settings['theme_id'] = isset($_GET['th']) ? (int) $_GET['th'] : (int) $_GET['id'];
Index: smf/Themes/default/ManageAttachments.template.php
===================================================================
--- smf/Themes/default/ManageAttachments.template.php	(revision 1047)
+++ smf/Themes/default/ManageAttachments.template.php	(working copy)
@@ -1,5 +1,5 @@
 <?php
-// Version: 1.1; ManageAttachments
+// Version: 1.1.9; ManageAttachments
 
 function template_manage_files_above()
 {
@@ -127,9 +127,6 @@
 			<td width="50%" align="right"><label for="attachmentExtensions">', $txt['attachmentExtensions'], '</label>:</td>
 			<td><input type="text" name="attachmentExtensions" id="attachmentExtensions" value="', $modSettings['attachmentExtensions'], '" size="40" /></td>
 		</tr><tr class="windowbg2">
-			<td width="50%" align="right"><label for="attachmentEncryptFilenames">', $txt['attachmentEncryptFilenames'], ' <a href="', $scripturl, '?action=helpadmin;help=attachmentEncryptFilenames" onclick="return reqWin(this.href);" class="help">(?)</a>:</label></td>
-			<td><input type="checkbox" name="attachmentEncryptFilenames" id="attachmentEncryptFilenames" value="1" class="check"', empty($modSettings['attachmentEncryptFilenames']) ? '' : ' checked="checked"', ' /></td>
-		</tr><tr class="windowbg2">
 			<td colspan="2"><hr /></td>
 		</tr><tr class="windowbg2">
 			<td width="50%" align="right"><label for="attachmentUploadDir"', $context['valid_upload_dir'] ? '' : ' style="color: red; font-weight: bold;"', '>', $txt['attachmentUploadDir'], '</label>:</td>
